#ifndef _CHandleConnections_H_
#define _CHandleConnections_H_
#include "StdAfx.h"

class CShells;
class CHandleConnections
{
protected:
	LOGINFO* log;
	USERINFO* users;
	unsigned int current_users;

private:
	CShells* shell;

	void NewConnection(SOCKET l_socket, int *socket_list);	
	void ReadFromSocket(unsigned int id, int *socket_list);

	void AddConnectionToList(unsigned int id, SOCKET socket_id, sockaddr_in socket_info);
	void RemoveConnectionFromList(unsigned int id, int* socket_list);

	bool UserPasswordIsValid(USERINFO* user);

public:
	CHandleConnections();
	CHandleConnections(LOGINFO* _log_info);
	virtual ~CHandleConnections();

	void HandleSockets(SOCKET l_socket, int *socket_list, fd_set* fd);
	void KeepAlive(int *socket_list, fd_set* fd, SOCKET l_socket);
	void CloseAllSockets(int* socketlist);
};


#endif
