#ifndef _CShells_h_
#define _CShells_h_
#include "StdAfx.h"

struct THREADINFO
{
	USERINFO* user;
	void* instance;
};

class CShells;
struct EMUSHELLCMDS
{
	std::string name;
	std::string descr;
	std::string (CShells::*func)();
};

class CShells
{
private:
	THREADINFO* thread;
	static void ShellThread(void* param);
	EMUSHELLCMDS* cmdfuncs;
	/*
		Emulated shell functions. Each function gets called from a different command.
		- Function -		- command -
		ListDirectory()		dir
		Help()				help

	*/
	std::string Help();
	std::string ListDirectory();

public:
	CShells();
	~CShells();
	void StartShell(USERINFO* user);
	void CloseShell(USERINFO* user);
	int WriteToShell(USERINFO* user);

	// 'derived' from the static function, so it doenst know any private variable/pointers
	// uhm, right
	int EmulatedShell(USERINFO* user);
	void ProgramShell(USERINFO* user);
};

#endif	// ifndef _CShells_h_