#ifndef _StdAfx_h_
#define _StdAfx_h_

/* includes */
#include <string>
#include <iostream>
#include <sstream>
#include <iomanip>
#include <cassert>
#ifndef _WIN32
	#error Operating System not supported!
#else
	#include <winsock2.h>
	#pragma comment(lib, "ws2_32")
	#include <windows.h>
#endif


/* defines */
#define VERSION	"1.0"							// current version
#define AUTHOR "NeWbY aka. Paul"				// original creater (me :P)
#define SHELL_DEFAULT_PROGRAM 1					// -s 1 (default shell)
#define SHELL_CUSTOM_PROGRAM 2					// -s 2 (custom shell)
#define SHELL_EMULATED_CMD 3					// -s 3 (emulated shell)
#define MAX_SOCKET_RECV 1024					// max recv size at a time
#define MAX_USER_INPUT 1024						// max characters a user can send at a time
#define MAX_PASSWORD_LENGTH 250					// max password length
#define WRITE_SHELL_FAILED 0					// error writing to shell
#define WRITE_SHELL_OK 1						// no error
#define WRITE_SHELL_EXIT 2						// we wrote the 'exit' string
typedef void* HANDLE;
typedef unsigned long (WINAPI* THREAD) (void *);	// THREAD function data type

/* declares */
typedef struct LOGINFO			// options
{
	char* ip;					// -c connect IP
	unsigned short port;		// -p PORT to use (0-65535)
	char* pass;					// -P Password
	unsigned int max_users;		// -u Max users

	int ShellType;

	bool UniqueShell;			// -U Every connection gets own shell
	bool UseLog;				// -L LOG on(1)/off(0)
	unsigned int timeout;		// -t Timeout (in seconds)

	bool ForceClosed;			// user did a ctrl+c ?
	char* ShellProgram;			// -s 2
	bool TimeoutExpired;
} LOGINFO;

typedef struct PROCESSINFO
{
	SECURITY_ATTRIBUTES secattr;
	STARTUPINFO si;
	PROCESS_INFORMATION pi;
} PROCESSINFO;

typedef struct SHELLINFO {
	HANDLE h_thread;
	HANDLE cmd_read;
	HANDLE cmd_write;
	HANDLE socket_read;
	HANDLE socket_write;
	unsigned long b_read;
	unsigned long b_avail;
	unsigned long b_written;
	unsigned int b_recv;
	unsigned long thread_id;
	char RecvCmd[MAX_SOCKET_RECV+1];
	PROCESSINFO process;
} SHELLINFO;

typedef struct USERINFO
{
	bool is_authed;						// is the user authed ? 1 - true : 0 - false
	unsigned int user_id;				// id in socket list (max_users - 1)
	SOCKET s_id;						// socket ID of accept()
	sockaddr_in s_info;					// socket info, IP, port etc.
	char s_recv[MAX_SOCKET_RECV+1];		// socket recv buffer
	int b_recv;							// bytes received from the socket
	unsigned short shell_t;				// user has a shell ? 0 - false, 1 - 3 shell type
	char* shell_program;				// pointer to the program
	SHELLINFO shell;					// shell info
} USERINFO;

typedef struct SHELLTYPES
{
	int id;
	std::string descr;
} SHELLTYPES;
static SHELLTYPES shelltypes[] = {
	{0, ""},
	{1, "default program - cmd.exe"},
	{2, "custom program"},
	{3, "emulated cmd.exe"}
	//{4, "user decision"}
};

#endif	// ifndef _StdAfx_h_